import javax.swing.*;
import java.awt.event.*;
import java.beans.*; // Property change stuff

/**
 * This class opens a window to enter information about the new
 * Layer. Possibly this should be modified to make it possible to
 * change layer information too.
 *
 * @author Alberto Manuel Brando Simes
 */
public class MapAddLayer extends JDialog {

    private JTextField title;
    private JTextField description;
    private JOptionPane optionPane;

    public String getLayerName() {
	return title.getText();
    }

    public String getLayerDescription() {
	return description.getText();
    }

    public MapAddLayer(MapViewer view, Map map) {
	super(view, true);
	setTitle("Add map layer");

	// Title
	title = new JTextField(30);
	title.setText("");
	// Description
	description = new JTextField(30);
	description.setText("");
	
	Object[] text = {"Layer name:", title, "Layer description:", description };

	final String btnEnter = "Enter";
	final String btnCancel = "Cancel";
	Object[] options = {btnEnter, btnCancel};

	optionPane = new JOptionPane(text, 
				     JOptionPane.QUESTION_MESSAGE,
				     JOptionPane.YES_NO_OPTION,
				     null,
				     options,
				     options[0]);
	setContentPane(optionPane);
	setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);

	// This makes the close operation to be sent to the optionPane
	addWindowListener(new WindowAdapter() {
		public void windowClosing(WindowEvent we) {
		    optionPane.setValue(new Integer(JOptionPane.CLOSED_OPTION));
		}
	    });

	optionPane.addPropertyChangeListener(new PropertyChangeListener() {
		public void propertyChange(PropertyChangeEvent e) {
		    String property = e.getPropertyName();

		    if (isVisible() &&
			(property.equals(JOptionPane.VALUE_PROPERTY) ||
			 property.equals(JOptionPane.INPUT_VALUE_PROPERTY))) {
			Object value = optionPane.getValue();
			
			if (value == JOptionPane.UNINITIALIZED_VALUE) {
			    //ignore reset
			    return;
			}
			
			optionPane.setValue(JOptionPane.UNINITIALIZED_VALUE);
			
			if (value.equals(btnEnter)) {
			    // Do something and... disappear
			    setVisible(false);
			} else {
			    // User clicked cancel or closed the window
			    title.setText(null);
			    setVisible(false);
			}
		    }
		}
	    });

	pack();
    }

}
